VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIEnumNetworkConnections"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: Frank Schler
' Datum: 03.08.2018
' Status: Komplett

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CLSID_EnumNetworkConnections As String = ""
Private Const IID_IEnumNetworkConnections As String = "{DCB00006-570F-4A9B-8D69-199FDBA5723B}"

Private Enum E_vtbOffsets
    ' /*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    ' /*** IDispatch methods ***/
    vtb_GetTypeInfoCount
    vtb_GetTypeInfo
    vtb_GetIDsOfNames
    vtb_Invoke
    ' /*** IEnumNetworkConnections methods ***/
    vtb_get__NewEnum
    vtb_Fetch 'Next
    vtb_Skip
    vtb_Reset
    vtb_Clone
End Enum

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== IUnknown Func ====----
'
'    /// <summary>
'    /// Retrieves pointers to the supported interfaces on an object.
'    /// </summary>
'   HRESULT QueryInterface(
'       REFIID riid,
'       void   **ppvObject
'       );
Public Function QueryInterface(ByVal riid As String) As Long

    Dim lRet As Long
    Dim triid(3) As Long
    Dim psriid As Long
    Dim ptriid As Long
    Dim ppvObject As Long
    Dim pppvObject As Long

    lRet = 0
    
    ' Pointer
    psriid = StrPtr(riid)
    ptriid = VarPtr(triid(0))

    ' IID -> triid
    If IIDFromString(psriid, ptriid) = S_OK Then
    
        ' Pointer
        pppvObject = VarPtr(ppvObject)

        ' QueryInterface des Interfaces aufrufen
        If x_OleInvoke(vtb_QueryInterface, ptriid, pppvObject) = S_OK Then

            lRet = ppvObject
        
        End If

    End If

    QueryInterface = lRet

End Function

' ----==== IEnumNetworkConnections Func ====----
'
Public Function get__NewEnum() As Long

    Dim pRet As Long
    Dim ppEnumVar As Long
    Dim pppEnumVar As Long

    pppEnumVar = VarPtr(ppEnumVar)

    If x_OleInvoke(vtb_get__NewEnum, pppEnumVar) = S_OK Then

        pRet = ppEnumVar

    End If

    get__NewEnum = pRet

End Function

Public Function Fetch(ByVal celt As Long, ByRef rgelt As Long, ByRef pceltFetched _
    As Long) As Boolean

    Dim bRet As Boolean
    Dim ppceltFetched As Long

    bRet = False
    ppceltFetched = VarPtr(pceltFetched)

    If x_OleInvoke(vtb_Fetch, celt, rgelt, pceltFetched) = S_OK Then

        bRet = True

    End If

    Fetch = bRet

End Function

Public Function Skip(ByVal celt As Long) As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Skip, celt) = S_OK Then

        bRet = True

    End If

    Skip = bRet

End Function

Public Function Reset() As Boolean

    Dim bRet As Boolean

    bRet = False

    If x_OleInvoke(vtb_Reset) = S_OK Then

        bRet = True

    End If

    Reset = bRet

End Function

Public Function Clone() As Long

    Dim lRet As Long
    Dim ppEnum As Long
    Dim pppenum As Long

    pppenum = VarPtr(ppEnum)

    If x_OleInvoke(vtb_Clone, pppenum) = S_OK Then

        lRet = ppEnum

    End If

    Clone = lRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Variant
    
    Dim varRet As Variant
    
    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        varRet = OleInvoke(m_Interface, vtb, var)
        
        ' nur falls ein Feler auftritt
        If varRet <> S_OK Then
        
            Debug.Print TypeName(Me) & ": E_vtbOffsets = " & CStr(vtb)
        
        End If
        
        x_OleInvoke = varRet

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property



