VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINetwork"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: Frank Schler
' Datum: 03.08.2018
' Status: Komplett, die Set-Funktionen noch nicht getestet!

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CLSID_Network As String = ""
Private Const IID_INetwork As String = "{DCB00002-570F-4A9B-8D69-199FDBA5723B}"

Private Enum E_vtbOffsets
    ' /*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    ' /*** IDispatch methods ***/
    vtb_GetTypeInfoCount
    vtb_GetTypeInfo
    vtb_GetIDsOfNames
    vtb_Invoke
    ' /*** INetwork methods ***/
    vtb_GetName
    vtb_SetName
    vtb_GetDescription
    vtb_SetDescription
    vtb_GetNetworkId
    vtb_GetDomainType
    vtb_GetNetworkConnections
    vtb_GetTimeCreatedAndConnected
    vtb_get_IsConnectedToInternet
    vtb_get_IsConnected
    vtb_GetConnectivity
    vtb_GetCategory
    vtb_SetCategory
End Enum

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== IUnknown Func ====----
'
'    /// <summary>
'    /// Retrieves pointers to the supported interfaces on an object.
'    /// </summary>
'   HRESULT QueryInterface(
'       REFIID riid,
'       void   **ppvObject
'       );
Public Function QueryInterface(ByVal riid As String) As Long

    Dim lRet As Long
    Dim triid(3) As Long
    Dim psriid As Long
    Dim ptriid As Long
    Dim ppvObject As Long
    Dim pppvObject As Long

    lRet = 0
    
    ' Pointer
    psriid = StrPtr(riid)
    ptriid = VarPtr(triid(0))

    ' IID -> triid
    If IIDFromString(psriid, ptriid) = S_OK Then
    
        ' Pointer
        pppvObject = VarPtr(ppvObject)

        ' QueryInterface des Interfaces aufrufen
        If x_OleInvoke(vtb_QueryInterface, ptriid, pppvObject) = S_OK Then

            lRet = ppvObject
        
        End If

    End If

    QueryInterface = lRet

End Function

' ----==== INetwork Func ====----
'
Public Function GetName() As String

    Dim sRet As String
    Dim pszNetworkName As Long
    Dim ppszNetworkName As Long

    ppszNetworkName = VarPtr(pszNetworkName)

    If x_OleInvoke(vtb_GetName, ppszNetworkName) = S_OK Then

        sRet = BSTR2String(pszNetworkName)

    End If

    GetName = sRet

End Function

Public Function SetName(ByVal szNetworkNewName As String) As Boolean

    Dim bRet As Boolean
    Dim pszNetworkNewName As Long

    bRet = False
    pszNetworkNewName = StrPtr(szNetworkNewName)

    If x_OleInvoke(vtb_SetName, pszNetworkNewName) = S_OK Then

        bRet = True

    End If

    SetName = bRet

End Function

Public Function GetDescription() As String

    Dim sRet As String
    Dim pszDescription As Long
    Dim ppszDescription As Long

    ppszDescription = VarPtr(pszDescription)

    If x_OleInvoke(vtb_GetDescription, ppszDescription) = S_OK Then

        sRet = BSTR2String(pszDescription)

    End If

    GetDescription = sRet

End Function

Public Function SetDescription(ByVal szDescription As String) As Boolean

    Dim bRet As Boolean
    Dim pszDescription As Long

    bRet = False
    pszDescription = StrPtr(szDescription)

    If x_OleInvoke(vtb_SetDescription, pszDescription) = S_OK Then

        bRet = True

    End If

    SetDescription = bRet

End Function

Friend Function GetNetworkId() As GUID

    Dim tRet As GUID
    Dim gdGuidNetworkId As GUID
    Dim pgdGuidNetworkId As Long

    pgdGuidNetworkId = VarPtr(gdGuidNetworkId)

    If x_OleInvoke(vtb_GetNetworkId, pgdGuidNetworkId) = S_OK Then

        tRet = gdGuidNetworkId

    End If

    GetNetworkId = tRet

End Function

Public Function GetDomainType() As NLM_DOMAIN_TYPE

    Dim eRet As NLM_DOMAIN_TYPE
    Dim pNetworkType As Long
    Dim ppNetworkType As Long

    ppNetworkType = VarPtr(pNetworkType)

    If x_OleInvoke(vtb_GetDomainType, ppNetworkType) = S_OK Then

        eRet = pNetworkType

    End If

    GetDomainType = eRet

End Function

Public Function GetNetworkConnections() As Long

    Dim pRet As Long
    Dim pEnumNetworkConnection As Long
    Dim ppEnumNetworkConnection As Long

    ppEnumNetworkConnection = VarPtr(pEnumNetworkConnection)

    If x_OleInvoke(vtb_GetNetworkConnections, ppEnumNetworkConnection) = S_OK Then

        pRet = pEnumNetworkConnection

    End If

    GetNetworkConnections = pRet

End Function

Friend Function GetTimeCreatedAndConnected(ByRef tDateTimeCreated As FILETIME, _
    ByRef tDateTimeConnected As FILETIME) As Boolean

    Dim bRet As Boolean
    Dim pdwLowDateTimeCreated As Long
    Dim pdwHighDateTimeCreated As Long
    Dim pdwLowDateTimeConnected As Long
    Dim pdwHighDateTimeConnected As Long
    Dim ppdwLowDateTimeCreated As Long
    Dim ppdwHighDateTimeCreated As Long
    Dim ppdwLowDateTimeConnected As Long
    Dim ppdwHighDateTimeConnected As Long

    bRet = False
    ppdwLowDateTimeCreated = VarPtr(pdwLowDateTimeCreated)
    ppdwHighDateTimeCreated = VarPtr(pdwHighDateTimeCreated)
    ppdwLowDateTimeConnected = VarPtr(pdwLowDateTimeConnected)
    ppdwHighDateTimeConnected = VarPtr(pdwHighDateTimeConnected)

    If x_OleInvoke(vtb_GetTimeCreatedAndConnected, ppdwLowDateTimeCreated, _
        ppdwHighDateTimeCreated, ppdwLowDateTimeConnected, _
        ppdwHighDateTimeConnected) = S_OK Then

        bRet = True
        tDateTimeCreated.dwLowDateTime = pdwLowDateTimeCreated
        tDateTimeCreated.dwHighDateTime = pdwHighDateTimeCreated
        tDateTimeConnected.dwLowDateTime = pdwLowDateTimeConnected
        tDateTimeConnected.dwHighDateTime = pdwHighDateTimeConnected

    End If

    GetTimeCreatedAndConnected = bRet

End Function

Public Function get_IsConnectedToInternet() As Boolean

    Dim bRet As Boolean
    Dim bIsConnected As Boolean
    Dim pbIsConnected As Long

    bRet = False
    pbIsConnected = VarPtr(bIsConnected)

    If x_OleInvoke(vtb_get_IsConnectedToInternet, pbIsConnected) = S_OK Then

        bRet = bIsConnected

    End If

    get_IsConnectedToInternet = bRet

End Function

Public Function get_IsConnected() As Boolean

    Dim bRet As Boolean
    Dim bIsConnected As Boolean
    Dim pbIsConnected As Long

    pbIsConnected = VarPtr(bIsConnected)

    If x_OleInvoke(vtb_get_IsConnected, pbIsConnected) = S_OK Then

        bRet = bIsConnected

    End If

    get_IsConnected = bRet

End Function

Public Function GetConnectivity() As NLM_CONNECTIVITY

    Dim eRet As NLM_CONNECTIVITY
    Dim pConnectivity As Long
    Dim ppConnectivity As Long

    ppConnectivity = VarPtr(pConnectivity)

    If x_OleInvoke(vtb_GetConnectivity, ppConnectivity) = S_OK Then

        eRet = pConnectivity

    End If

    GetConnectivity = eRet

End Function

Public Function GetCategory() As NLM_NETWORK_CATEGORY

    Dim eRet As NLM_NETWORK_CATEGORY
    Dim pCategory As Long
    Dim ppCategory As Long

    ppCategory = VarPtr(pCategory)

    If x_OleInvoke(vtb_GetCategory, ppCategory) = S_OK Then

        eRet = pCategory

    End If

    GetCategory = eRet

End Function

Public Function SetCategory(ByVal NewCategory As NLM_NETWORK_CATEGORY) As Boolean

    Dim bRet As Boolean
    Dim lNewCategory As Long
    Dim plNewCategory As Long

    bRet = False
    lNewCategory = CLng(NewCategory)
    plNewCategory = VarPtr(lNewCategory)

    If x_OleInvoke(vtb_SetCategory, plNewCategory) = S_OK Then

        bRet = True

    End If

    SetCategory = bRet

End Function

' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Public Sub Init(ByVal pInterface As Long)

    If pInterface <> 0& Then

        m_Interface.pObject = ObjPtr(Me)
        m_Interface.boolRaiseErrors = False
        m_Interface.pInterface = pInterface

    End If

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Variant
    
    Dim varRet As Variant
    
    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        varRet = OleInvoke(m_Interface, vtb, var)
        
        ' nur falls ein Feler auftritt
        If varRet <> S_OK Then
        
            Debug.Print TypeName(Me) & ": E_vtbOffsets = " & CStr(vtb)
        
        End If
        
        x_OleInvoke = varRet

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property



