VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINetworkEvents"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: Frank Schler
' Datum: 09.12.2019
' Status: Komplett

Option Explicit

' ----==== Events INetworkEvents ====----
Public Event NetworkAdded(ByVal networkID As String)
Public Event NetworkDeleted(ByVal networkID As String)
Public Event NetworkConnectivityChanged(ByVal networkID As String, ByVal newConnectivity As NLM_CONNECTIVITY)
Public Event NetworkPropertyChanged(ByVal networkID As String, ByVal flags As NLM_NETWORK_PROPERTY_CHANGE)

' ----==== Variablen ====----
Private pINetworkEvents As Long

Private Sub Class_Initialize()

    ' Interface INetworkEvents initialisieren
    pINetworkEvents = modINetworkEvents.INetworkEvents(ObjPtr(Me))

End Sub

Private Sub Class_Terminate()
    
    ' ist ein Pointer auf das Interface vorhanden
    If pINetworkEvents <> 0& Then
    
        ' ruft Release des Interfaces auf
        Call CoTaskMemFree(pINetworkEvents)
    
    End If
    
End Sub

' ----==== liefert den Pointer auf INetworkEvents zurck ====----
Public Function GetIPtr() As Long

    GetIPtr = pINetworkEvents

End Function

' ----==== Raise Events INetworkEvents ====----
'
Public Sub NetworkAdded(ByVal networkID As String)
    
    ' networkId As GUID
    RaiseEvent NetworkAdded(networkID)
    
End Sub

Public Sub NetworkDeleted(ByVal networkID As String)

    ' networkId As GUID
    RaiseEvent NetworkDeleted(networkID)

End Sub

Public Sub NetworkConnectivityChanged(ByVal networkID As String, ByVal newConnectivity As Long)

    ' networkId As GUID
    ' newConnectivity As NLM_CONNECTIVITY
    RaiseEvent NetworkConnectivityChanged(networkID, newConnectivity)

End Sub

Public Sub NetworkPropertyChanged(ByVal networkID As String, ByVal flags As Long)

    ' networkId As GUID
    ' flags As NLM_NETWORK_PROPERTY_CHANGE
    RaiseEvent NetworkPropertyChanged(networkID, flags)

End Sub
