VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsINetworkListManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: Frank Schler
' Datum: 09.12.2019
' Status: Komplett

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const CLSID_NetworkListManager As String = "{DCB00C01-570F-4A9B-8D69-199FDBA5723B}"
Private Const IID_INetworkListManager As String = "{DCB00000-570F-4A9B-8D69-199FDBA5723B}"
    
Private Enum E_vtbOffsets
    ' /*** IUnknown methods ***/
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    ' /*** IDispatch methods ***/
    vtb_GetTypeInfoCount
    vtb_GetTypeInfo
    vtb_GetIDsOfNames
    vtb_Invoke
    ' /*** INetworkListManager methods ***/
    vtb_GetNetworks
    vtb_GetNetwork
    vtb_GetNetworkConnections
    vtb_GetNetworkConnection
    vtb_get_IsConnectedToInternet
    vtb_get_IsConnected
    vtb_GetConnectivity
    vtb_SetSimulatedProfileInfo
    vtb_ClearSimulatedProfileInfo
End Enum

' ----==== Ole32 API-Deklarationen ====----
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

' ----==== Variablen ====----
Private m_Interface As InterfaceData

' ----==== IUnknown Func ====----
'
'    /// <summary>
'    /// Retrieves pointers to the supported interfaces on an object.
'    /// </summary>
'   HRESULT QueryInterface(
'       REFIID riid,
'       void   **ppvObject
'       );
Public Function QueryInterface(ByVal riid As String) As Long

    Dim lRet As Long
    Dim triid(3) As Long
    Dim psriid As Long
    Dim ptriid As Long
    Dim ppvObject As Long
    Dim pppvObject As Long

    lRet = 0
    
    ' Pointer
    psriid = StrPtr(riid)
    ptriid = VarPtr(triid(0))

    ' IID -> triid
    If IIDFromString(psriid, ptriid) = S_OK Then
    
        ' Pointer
        pppvObject = VarPtr(ppvObject)

        ' QueryInterface des Interfaces aufrufen
        If x_OleInvoke(vtb_QueryInterface, ptriid, pppvObject) = S_OK Then

            lRet = ppvObject
        
        End If

    End If

    QueryInterface = lRet

End Function

' ----==== INetworkListManager Func ====----
'
Public Function GetNetworks(ByVal flags As NLM_ENUM_NETWORK) As Long
    
    Dim pRet As Long
    Dim pEnumNetwork As Long
    Dim ppEnumNetwork As Long
    
    ppEnumNetwork = VarPtr(pEnumNetwork)
    
    If x_OleInvoke(vtb_GetNetworks, flags, ppEnumNetwork) = S_OK Then

        pRet = pEnumNetwork

    End If

    GetNetworks = pRet

End Function

Friend Function GetNetwork(ByRef gdNetworkId As GUID) As Long

    Dim pRet As Long
    Dim pNetwork As Long
    Dim ppNetwork As Long
    Dim pgdNetworkId As Long
    
    ppNetwork = VarPtr(pNetwork)
    pgdNetworkId = VarPtr(gdNetworkId)
    
    If x_OleInvoke(vtb_GetNetwork, pgdNetworkId, ppNetwork) = S_OK Then

        pRet = pNetwork

    End If

    GetNetwork = pRet

End Function

Public Function GetNetworkConnections() As Long

    Dim pRet As Long
    Dim pEnum As Long
    Dim ppEnum As Long

    ppEnum = VarPtr(pEnum)

    If x_OleInvoke(vtb_GetNetworkConnections, ppEnum) = S_OK Then

        pRet = pEnum

    End If

    GetNetworkConnections = pRet

End Function

Friend Function GetNetworkConnection(ByRef gdNetworkConnectionId As GUID) As Long

    Dim pRet As Long
    Dim pNetworkConnection As Long
    Dim ppNetworkConnection As Long
    Dim pgdNetworkConnectionId As Long
    
    ppNetworkConnection = VarPtr(pNetworkConnection)
    pgdNetworkConnectionId = VarPtr(gdNetworkConnectionId)
    
    If x_OleInvoke(vtb_GetNetworkConnection, pgdNetworkConnectionId, ppNetworkConnection) = S_OK Then

        pRet = pNetworkConnection

    End If

    GetNetworkConnection = pRet

End Function

Public Function get_IsConnectedToInternet() As Boolean

    Dim bRet As Boolean
    Dim bIsConnected As Boolean
    Dim pbIsConnected As Long
    
    pbIsConnected = VarPtr(bIsConnected)
    
    If x_OleInvoke(vtb_get_IsConnectedToInternet, pbIsConnected) = S_OK Then

        bRet = bIsConnected

    End If

    get_IsConnectedToInternet = bRet

End Function

Public Function get_IsConnected() As Boolean

    Dim bRet As Boolean
    Dim bIsConnected As Boolean
    Dim pbIsConnected As Long
    
    pbIsConnected = VarPtr(bIsConnected)
    
    If x_OleInvoke(vtb_get_IsConnected, pbIsConnected) = S_OK Then

        bRet = bIsConnected

    End If

    get_IsConnected = bRet

End Function

Public Function GetConnectivity() As NLM_CONNECTIVITY

    Dim eRet As NLM_CONNECTIVITY
    Dim pConnectivity As Long
    Dim ppConnectivity As Long
    
    ppConnectivity = VarPtr(pConnectivity)

    If x_OleInvoke(vtb_GetConnectivity, ppConnectivity) = S_OK Then

        eRet = pConnectivity

    End If

    GetConnectivity = eRet

End Function

Friend Function SetSimulatedProfileInfo(ByRef tSimulatedInfo As _
    NLM_SIMULATED_PROFILE_INFO) As Boolean

    Dim bRet As Boolean
    Dim pSimulatedInfo As Long

    bRet = False
    pSimulatedInfo = VarPtr(tSimulatedInfo)

    If x_OleInvoke(vtb_SetSimulatedProfileInfo, pSimulatedInfo) = S_OK Then

        bRet = True

    End If

    SetSimulatedProfileInfo = bRet

End Function

Public Function ClearSimulatedProfileInfo() As Boolean

    Dim bRet As Boolean
    
    bRet = False

    If x_OleInvoke(vtb_ClearSimulatedProfileInfo) = S_OK Then

        bRet = True

    End If

    ClearSimulatedProfileInfo = bRet

End Function


' ----==== Interface Helper Func ====----
'
' Initialisiert das Interface ber einen Interface-Pointer
Private Sub Class_Initialize()

    m_Interface.pObject = ObjPtr(Me)
    m_Interface.boolRaiseErrors = False

    Call InitInterface(m_Interface, CLSID_NetworkListManager, _
        IID_INetworkListManager)

End Sub

' Ruft Release des Interfaces auf
Private Sub Class_Terminate()

    Call ReleaseInterface(m_Interface)

End Sub

' Fhrt die Funktion des Interfaces aus
Private Function x_OleInvoke(ByVal vtb As E_vtbOffsets, ParamArray var()) As Variant
    
    Dim varRet As Variant
    
    ' ist ein Pointer auf ein Interface vorhanden
    If m_Interface.pInterface <> 0& Then

        ' Funktion ausfhren
        varRet = OleInvoke(m_Interface, vtb, var)
        
        ' nur falls ein Feler auftritt
        If varRet <> S_OK Then
        
            Debug.Print TypeName(Me) & ": E_vtbOffsets = " & CStr(vtb)
        
        End If
        
        x_OleInvoke = varRet

    End If

End Function

' wird aus der modInterface bei einem Fehler aufgerufen
Public Sub x_RaiseError(ByVal lngErrCode As Long, ByVal strErrText As String)

    Call Err.Raise(lngErrCode, App.EXEName & "\" & TypeName(Me), strErrText)

End Sub

' Fehler auslsen? Standard = False
Public Property Let RaiseErrors(ByVal Raise As Boolean)

    m_Interface.boolRaiseErrors = Raise

End Property

' liefert den Pointer auf das Interface zurck
Public Property Get IfcPtr() As Long

    IfcPtr = m_Interface.pInterface

End Property

