Attribute VB_Name = "modINetworkListManagerEvents"
' Autor: Frank Schler
' Datum: 09.12.2019
' Status: Komplett

Option Explicit

' ----==== Const ====----
Private Const S_OK As Long = &H0
Private Const E_NOINTERFACE As Long = &H80004002
Private Const IID_IUnknown As String = "{00000000-0000-0000-C000-000000000046}"
Private Const IID_INetworkListManagerEvents As String = "{DCB00001-570F-4A9B-8D69-199FDBA5723B}"

' ----==== Types ====----
Private Type tIUnknown
    pVTable As Long
End Type

Private Type tIUnknownVTable
    VTable(0 To 2) As Long
End Type

Private Type tINetworkListManagerEvents
    pVTable As Long
End Type

Private Type tINetworkListManagerEventsVTable
    VTable(0 To 3) As Long
End Type

' ----==== Kernel32 API-Deklarationen ====----
Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal length As Long)

' ----==== Variablen ====----
Private m_IPtr As Long
Private m_RefCount As Long
Private m_Interface As Object
Private m_IUnknown As tIUnknown
Private m_IUnknownVTable As tIUnknownVTable
Private m_INetworkListManagerEvents As tINetworkListManagerEvents
Private m_INetworkListManagerEventsVTable As tINetworkListManagerEventsVTable

Public Function INetworkListManagerEvents(ByVal cINetworkListManagerEvents As Long) As Long

    ' Objekt vom Pointer
    Call CopyMemory(m_Interface, cINetworkListManagerEvents, 4)

    ' ----==== Interface IUnknown  ====----
    With m_IUnknownVTable
        
        ' VTable aufbauen
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)

    End With

    With m_IUnknown

        ' Pointer auf die VTable
        .pVTable = VarPtr(m_IUnknownVTable)

    End With

    ' ----==== Interface INetworkListManagerEvents  ====----
    With m_INetworkListManagerEventsVTable
        
        ' VTable aufbauen
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)
        .VTable(3) = ProcPtr(AddressOf ConnectivityChanged)

    End With

    With m_INetworkListManagerEvents

        ' Pointer auf die VTable
        .pVTable = VarPtr(m_INetworkListManagerEventsVTable)

    End With

    ' Pointer auf das Interface
    m_IPtr = VarPtr(m_IUnknown)

    INetworkListManagerEvents = m_IPtr

End Function

Private Function ProcPtr(ByVal ptr As Long) As Long

    ProcPtr = ptr

End Function

' ----==== Interface IUnknown Func ====----
Private Function QueryInterface(ByVal this As Long, ByRef riid As GUID, ByRef _
    pvObj As Long) As Long

    Dim lRet As Long
        
    Select Case UCase$(Guid2String(riid))
    
    ' wenn nach dem Interface IUnknown gefragt wird
    Case UCase$(IID_IUnknown)
    
        ' dann muss ein AddRef aufgerufen werden.
        Call AddRef(this)
        
        ' Pointer auf das Interface
        pvObj = VarPtr(m_IUnknown)
        
        ' OK zurck geben, Interface ist vorhanden
        lRet = S_OK

    ' wenn nach dem Interface INetworkListManagerEvents gefragt wird
    Case UCase$(IID_INetworkListManagerEvents)

        ' dann muss ein AddRef aufgerufen werden.
        Call AddRef(this)
        
        ' Pointer auf das Interface
        pvObj = VarPtr(m_INetworkListManagerEvents)
        
        ' OK zurck geben, Interface ist vorhanden
        lRet = S_OK

    Case Else
        
        ' alles andere ignorieren
        
        pvObj = 0&
        
        lRet = E_NOINTERFACE
    
    End Select

    QueryInterface = lRet

End Function

Private Function AddRef(ByVal this As Long) As Long

    m_RefCount = m_RefCount + 1

    AddRef = m_RefCount

End Function

Private Function Release(ByVal this As Long) As Long
    
    m_RefCount = m_RefCount - 1
    
    If m_RefCount = 0 Then
    
        ' alles Aufrumen und Freigeben
        m_IUnknown.pVTable = 0&
        Erase m_IUnknownVTable.VTable
        
        m_INetworkListManagerEvents.pVTable = 0&
        Erase m_INetworkListManagerEventsVTable.VTable
        
        m_IPtr = 0&
        
        ' Objekt lschen
        Call CopyMemory(m_Interface, 0&, 4)
        
    End If
    
    Release = m_RefCount

End Function

' ----==== Interface INetworkListManagerEvents Func ====----
'
Private Function ConnectivityChanged(ByVal this As Long, ByVal newConnectivity As Long) As Long

    ' Funktion in der Klasse aufrufen
    Call m_Interface.ConnectivityChanged(newConnectivity)

End Function

