Attribute VB_Name = "modNetworkListManager"
' Autor: Frank Schler
' Datum: 03.08.2018
' Status: in Arbeit

Option Explicit

Private Const S_OK As Long = &H0

Public Enum PROPERTYBAG_NAMES
    NA_AllowMerge = 0
    NA_CategorySetByPolicy
    NA_CategoryReadOnly
    NA_DescriptionSetByPolicy
    NA_DescriptionReadOnly
    NA_DomainAuthenticationFailed
    NA_IconSetByPolicy
    NA_IconReadOnly
    NA_InternetConnectivityV4
    NA_InternetConnectivityV6
    NA_NameSetByPolicy
    NA_NameReadOnly
    NA_NetworkClass
End Enum

Public Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliSeconds As Integer
End Type

Public Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte
End Type

Public Type GUIDL
    Data1 As Long
    Data2 As Long
    Data3 As Long
    Data4 As Long
End Type

Public Type EXCEPINFO
    wCode As Integer
    wReserved As Integer
    bstrSource As String
    bstrDescription As String
    bstrHelpFile As String
    dwHelpContext As Long
    pvReserved As Long
    pfnDeferredFillIn As Long
    scode As Long
End Type

Public Type CONNECTDATA
    pUnk As Long
    dwCookie As Long
End Type

Public Enum NLM_NETWORK_CLASS
    NLM_NETWORK_IDENTIFYING = &H1
    NLM_NETWORK_IDENTIFIED = &H2
    NLM_NETWORK_UNIDENTIFIED = &H3
End Enum

Public Enum NLM_INTERNET_CONNECTIVITY
    NLM_INTERNET_CONNECTIVITY_WEBHIJACK = &H1
    NLM_INTERNET_CONNECTIVITY_PROXIED = &H2
    NLM_INTERNET_CONNECTIVITY_CORPORATE = &H4
End Enum

Public Enum NLM_CONNECTIVITY
    NLM_CONNECTIVITY_DISCONNECTED = &H0
    NLM_CONNECTIVITY_IPV4_NOTRAFFIC = &H1
    NLM_CONNECTIVITY_IPV6_NOTRAFFIC = &H2
    NLM_CONNECTIVITY_IPV4_SUBNET = &H10
    NLM_CONNECTIVITY_IPV4_LOCALNETWORK = &H20
    NLM_CONNECTIVITY_IPV4_INTERNET = &H40
    NLM_CONNECTIVITY_IPV6_SUBNET = &H100
    NLM_CONNECTIVITY_IPV6_LOCALNETWORK = &H200
    NLM_CONNECTIVITY_IPV6_INTERNET = &H400
End Enum

Public Enum NLM_DOMAIN_TYPE
    NLM_DOMAIN_TYPE_NON_DOMAIN_NETWORK = &H0
    NLM_DOMAIN_TYPE_DOMAIN_NETWORK = &H1
    NLM_DOMAIN_TYPE_DOMAIN_AUTHENTICATED = &H2
End Enum
    
Public Enum NLM_ENUM_NETWORK
    NLM_ENUM_NETWORK_CONNECTED = &H1
    NLM_ENUM_NETWORK_DISCONNECTED = &H2
    NLM_ENUM_NETWORK_ALL = &H3
End Enum

Public Enum NLM_NETWORK_CATEGORY
    NLM_NETWORK_CATEGORY_PUBLIC = &H0
    NLM_NETWORK_CATEGORY_PRIVATE = &H1
    NLM_NETWORK_CATEGORY_DOMAIN_AUTHENTICATED = &H2
End Enum

Public Enum NLM_NETWORK_PROPERTY_CHANGE
    NLM_NETWORK_PROPERTY_CHANGE_CONNECTION = &H1
    NLM_NETWORK_PROPERTY_CHANGE_DESCRIPTION = &H2
    NLM_NETWORK_PROPERTY_CHANGE_NAME = &H4
    NLM_NETWORK_PROPERTY_CHANGE_ICON = &H8
    NLM_NETWORK_PROPERTY_CHANGE_CATEGORY_VALUE = &H10
End Enum

Public Enum NLM_CONNECTION_PROPERTY_CHANGE
    NLM_CONNECTION_PROPERTY_CHANGE_AUTHENTICATION = &H1&
End Enum

Public Enum NLM_CONNECTION_COST
    NLM_CONNECTION_COST_UNKNOWN = &H0
    NLM_CONNECTION_COST_UNRESTRICTED = &H1
    NLM_CONNECTION_COST_FIXED = &H2
    NLM_CONNECTION_COST_VARIABLE = &H4
    NLM_CONNECTION_COST_OVERDATALIMIT = &H10000
    NLM_CONNECTION_COST_CONGESTED = &H20000
    NLM_CONNECTION_COST_ROAMING = &H40000
    NLM_CONNECTION_COST_APPROACHINGDATALIMIT = &H80000
End Enum

Public Type NLM_SIMULATED_PROFILE_INFO
    ProfileName(255) As Byte
    Cost As NLM_CONNECTION_COST
    UsageInMegabytes As Long
    DataLimitInMegabytes As Long
End Type

Public Enum VARENUM
   VT_EMPTY = &H0
   VT_NULL = &H1
   VT_I2 = &H2
   VT_I4 = &H3
   VT_R4 = &H4
   VT_R8 = &H5
   VT_CY = &H6
   VT_DATE = &H7
   VT_BSTR = &H8
   VT_DISPATCH = &H9
   VT_ERROR = &HA
   VT_BOOL = &HB
   VT_VARIANT = &HC
   VT_UNKNOWN = &HD
   VT_DECIMAL = &HE
   VT_I1 = &H10
   VT_UI1 = &H11
   VT_UI2 = &H12
   VT_UI4 = &H13
   VT_I8 = &H14
   VT_UI8 = &H15
   VT_INT = &H16
   VT_UINT = &H17
   VT_VOID = &H18
   VT_HRESULT = &H19
   VT_PTR = &H1A
   VT_SAFEARRAY = &H1B
   VT_CARRAY = &H1C
   VT_USERDEFINED = &H1D
   VT_LPSTR = &H1E
   VT_LPWSTR = &H1F
   VT_RECORD = &H24
   VT_INT_PTR = &H25
   VT_UINT_PTR = &H26
   VT_ARRAY = &H2000
   VT_BYREF = &H4000
End Enum

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    dwPadBytes As Long
End Type

' **************** Kernel32.dll ****************
Private Declare Sub CopyMemory Lib "kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef dest As Any, _
                    ByRef Source As Any, _
                    ByVal bytes As Long)

Private Declare Function FileTimeToLocalFileTime Lib "kernel32.dll" ( _
                         ByRef lpFileTime As FILETIME, _
                         ByRef lpLocalFileTime As FILETIME) As Long

Private Declare Function FileTimeToSystemTime Lib "kernel32.dll" ( _
                         ByRef lpFileTime As FILETIME, _
                         ByRef lpSystemTime As SYSTEMTIME) As Long

' **************** Ole32.dll ****************
Public Declare Sub CoTaskMemFree Lib "ole32.dll" ( _
                   ByVal hMem As Long)

Private Declare Function StringFromGUID Lib "ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long

Private Declare Function StringFromGUIDL Lib "ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUIDL, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long

Public Function GetPropertyBagNames(ByVal eNames As PROPERTYBAG_NAMES) As String

    Dim sRet As String

    Select Case eNames

    Case PROPERTYBAG_NAMES.NA_AllowMerge
        sRet = "NA_AllowMerge"

    Case PROPERTYBAG_NAMES.NA_CategorySetByPolicy
        sRet = "NA_CategorySetByPolicy"

    Case PROPERTYBAG_NAMES.NA_CategoryReadOnly
        sRet = "NA_CategoryReadOnly"

    Case PROPERTYBAG_NAMES.NA_DescriptionSetByPolicy
        sRet = "NA_DescriptionSetByPolicy"

    Case PROPERTYBAG_NAMES.NA_DescriptionReadOnly
        sRet = "NA_DescriptionReadOnly"

    Case PROPERTYBAG_NAMES.NA_DomainAuthenticationFailed
        sRet = "NA_DomainAuthenticationFailed"

    Case PROPERTYBAG_NAMES.NA_IconSetByPolicy
        sRet = "NA_IconSetByPolicy"

    Case PROPERTYBAG_NAMES.NA_IconReadOnly
        sRet = "NA_IconReadOnly"

    Case PROPERTYBAG_NAMES.NA_InternetConnectivityV4
        sRet = "NA_InternetConnectivityV4"

    Case PROPERTYBAG_NAMES.NA_InternetConnectivityV6
        sRet = "NA_InternetConnectivityV6"

    Case PROPERTYBAG_NAMES.NA_NameSetByPolicy
        sRet = "NA_NameSetByPolicy"

    Case PROPERTYBAG_NAMES.NA_NameReadOnly
        sRet = "NA_NameReadOnly"

    Case PROPERTYBAG_NAMES.NA_NetworkClass
        sRet = "NA_NetworkClass"

    End Select

    GetPropertyBagNames = sRet

End Function

Public Function StringFromFileTime(ByRef tFileTime As FILETIME) As String

    Dim sRet As String
    Dim tLocalFileTime As FILETIME
    Dim tLocalSystemTime As SYSTEMTIME

    If FileTimeToLocalFileTime(tFileTime, tLocalFileTime) <> 0 Then
    
        If FileTimeToSystemTime(tLocalFileTime, tLocalSystemTime) <> 0 Then

            With tLocalSystemTime

                sRet = Format$(.wDay, "00") & "." & Format$(.wMonth, "00") & _
                    "." & Format$(.wYear, "0000") & " " & Format$(.wHour, "00") & _
                    ":" & Format$(.wMinute, "00") & ":" & Format$(.wSecond, _
                    "00")

            End With

        End If
        
    End If

    StringFromFileTime = sRet

End Function

Public Function BSTR2String(ByVal pStr As Long) As String

    Dim strTmp As String
    Dim strRet As String
    Dim pstrTmp As Long

    pstrTmp = VarPtr(strTmp)

    Call CopyMemory(ByVal pstrTmp, pStr, 4)

    strRet = strTmp

    pstrTmp = VarPtr(strTmp)

    Call CopyMemory(ByVal pstrTmp, 0&, 4)

    BSTR2String = strRet

End Function

Public Function Guid2String(ByRef tGUID As GUID) As String

    Dim lRet As Long
    Dim sGUID As String

    sGUID = String(40, 0)

    lRet = StringFromGUID(tGUID, StrPtr(sGUID), Len(sGUID))

    If lRet > 0 Then

        sGUID = Left$(sGUID, lRet - 1)

    Else

        sGUID = vbNullString

    End If

    Guid2String = sGUID

End Function

Public Function GuidL2String(ByRef tGUIDL As GUIDL) As String

    Dim lRet As Long
    Dim sGUID As String

    sGUID = String(40, 0)

    lRet = StringFromGUIDL(tGUIDL, StrPtr(sGUID), Len(sGUID))

    If lRet > 0 Then

        sGUID = Left$(sGUID, lRet - 1)

    Else

        sGUID = vbNullString

    End If

    GuidL2String = sGUID

End Function

